def divisible_by_7(n: int) -> list[int]:
    """
    Returns a list of all numbers till 'n' that are divisible by '7'
    """
    return [x for x in range(1, n) if x % 7 == 0]


def contains_3(n: int) -> list[int]:
    """
    Returns a list of all numbers that contain the digit '3' in them
    """
    return [x for x in range(1, n) if '3' in str(x)]


def count_spaces(string: str) -> int:
    """
    Count the spaces in a string
    """
    return len([ch for ch in string if ' ' == ch])


def remove_vowels(string: str) -> str:
    """
    Remove all vowels from the string
    """
    return ''.join([ch for ch in string if ch.lower() not in 'aeiou'])


def word_lengths(string: str) -> dict[str, int]:
    """
    Create a dictionary of all words with their lengths
    """
    return {word: len(word) for word in string.split(' ') if len(word) > 0}


def prime_numbers(n: int) -> list[int]:
    """
    Returns a list of all prime numbers till 'n' (HARD)
    """
    return [x for x in range(2, n) if all(x % y != 0 for y in range(2, x))]

